#import "AppDelegate.h"


@implementation AppDelegate

- (IBAction)thrower:(id)sender;
{
	NSError *error = nil;
	id result = [self fetchDocument:[NSURL URLWithString:@"http://www.apple.com"] error:&error];
	if (error) {
		[NSApp presentError:error];
		return;
	}
	
	NSLog(@"Result received: %@", result);
}

- (NSError*)application:(NSApplication*)app willPresentError:(NSError*)error;
{
    //Here we are going to inject our recovery options
    NSMutableDictionary *errorDetail = [[error userInfo] mutableCopy];
    NSArray *recoveryOptions = [NSArray arrayWithObjects:@"Try Again", @"Abort", nil];
    
    [errorDetail setObject:recoveryOptions
                    forKey:NSLocalizedRecoveryOptionsErrorKey];
    [errorDetail setValue:self 
                   forKey:NSRecoveryAttempterErrorKey];
    [errorDetail setValue:@"Attempt to fetch document again?"
                   forKey:NSLocalizedRecoverySuggestionErrorKey];
    
    NSError *newError = [NSError errorWithDomain:[error domain] code:[error code] userInfo:errorDetail];
    [errorDetail release], errorDetail = nil;
    return newError;
}

- (BOOL)attemptRecoveryFromError:(NSError *)error optionIndex:(NSUInteger)recoveryOptionIndex
{
    if (recoveryOptionIndex == 0) {
        //Correct the error
        return YES;
    }
    return NO;
}

- (id)fetchDocument:(NSURL*)url error:(NSError**)error
{
	NSString *myString = [[NSString alloc] initWithContentsOfURL:url];
	
	//start to do something wickedly cool with the data
	if (YES) {
		//An error occurred
		NSMutableDictionary *errorDetail = [NSMutableDictionary dictionary];
		[errorDetail setValue:@"Failed to do something wicked" forKey:NSLocalizedDescriptionKey];
		[errorDetail setValue:myString forKey:@"kReceivedData"];
        
		*error = [NSError errorWithDomain:@"myDomain" code:100 userInfo:errorDetail];
		return nil;
	}
	//Finish doing something wicked
	return [myString autorelease];
}
						  

@end
